<script setup lang="ts">
import VoteBox from '@/components/VoteBox.vue'
import { VoteInformation, VoteResults, type VoteQuestion } from '@/scripts/types'
import { useDataStore } from '@/store/data'
import { onMounted, reactive } from 'vue'
import { onBeforeRouteUpdate, useRoute } from 'vue-router'

type ParsedResults = { total: number, sums: number[], question: VoteQuestion }[]

const route = useRoute()
const data = useDataStore()

const state = reactive({
  vote: undefined as VoteInformation | undefined,
  rawResults: undefined as VoteResults | undefined,
  parsedResults: undefined as ParsedResults | undefined,
  foundMyBallot: undefined as boolean | undefined
})

onMounted(refresh)
onBeforeRouteUpdate((to, from, next) => {
  if (to.name === 'vote-results') {
    refresh()
  }
  next()
})

async function refresh() {
  const voteId = parseInt(route.params.id as string)
  await data.refreshVotes()
  const myBallot = data.savedBallots[voteId]
  state.foundMyBallot = myBallot == null ? undefined : false
  state.vote = data.votes.find(v => v.id === voteId)
  state.rawResults = await data.getResults(voteId)
  if (state.vote == null) {
    console.error('Vote is null')
    return
  }
  state.parsedResults = [] as ParsedResults
  for (const question of state.vote.questions) {
    state.parsedResults.push({
      question,
      total: 0,
      sums: question.options.map(() => 0)
    })
  }
  for (const ballot of state.rawResults.ballots) {
    console.log(ballot, myBallot)
    if (myBallot != null && JSON.stringify(myBallot) === JSON.stringify(ballot) ) {
      state.foundMyBallot = true
    }
    for (const [questionIndex, questionAnswers] of ballot.answers.entries()) {
      const a = state.parsedResults[questionIndex]
      let atLeastOneOption = false
      for (const [optionIndex, value] of questionAnswers.entries()) {
        if (value) {
          a.sums[optionIndex] += 1
          atLeastOneOption = true
        }
      }
      a.total += atLeastOneOption ? 1 : 0
    }
  }
}

</script>

<template>
  <div v-if="state.vote != null && state.parsedResults != null">
    <div class="flex flex-col px-3 max-w-2xl mx-auto">
      <div class="flex justify-between items-center">
        <h1 class="text-2xl">Résultats du vote #{{state.vote.id}}</h1>

        <v-chip v-if="state.foundMyBallot === undefined" class="mx-2" label size="x-small" >
          Vous n'avez pas voté
        </v-chip>
        <v-chip v-else-if="state.foundMyBallot === true" class="mx-2" label color="success" append-icon="mdi-lock" size="small" >
          Vote vérifié
        </v-chip>
        <v-chip v-else class="mx-2" label color="error" append-icon="mdi-alert-circle" size="small" >
          Échec de la vérification
        </v-chip>
      </div>

      <vote-box :vote="state.vote" class="my-2" mode="info"/>

      <div v-for="questionResults of state.parsedResults" v-bind:key="questionResults.question.question" class="mb-3">
        <h2 class="text-xl">Q: {{ questionResults.question.question }}</h2>
        <div v-for="[optionIndex, option] in questionResults.question.options.entries()" v-bind:key="option" class="mb-2">
          <p >
            {{ option }} : {{ questionResults.sums[optionIndex] }} / {{ questionResults.total  }}
          </p>
          <v-progress-linear rounded color="primary" :model-value="Math.round(100 * questionResults.sums[optionIndex] / questionResults.total)" :height="11" />
        </div>
      </div>

      <div class="my-5">
        <v-btn block variant="tonal" @click="$router.back">Retour</v-btn>
      </div>
    </div>
  </div>
</template>
